/* Generated test code to dump a table of data for external validation
 * of the noise model parameters.
 */
#include <stdio.h>
#include <assert.h>
double compute_noise_model_entry_S(int plane, int sens);
double compute_noise_model_entry_O(int plane, int sens);
int main(void) {
    for (int plane = 0; plane < 4; plane++) {
        for (int sens = 50; sens <= 800; sens += 100) {
            double o = compute_noise_model_entry_O(plane, sens);
            double s = compute_noise_model_entry_S(plane, sens);
            printf("%d,%d,%lf,%lf\n", plane, sens, o, s);
        }
    }
    return 0;
}

/* Generated functions to map a given sensitivity to the O and S noise
 * model parameters in the DNG noise model. The planes are in
 * R, Gr, Gb, B order.
 */
double compute_noise_model_entry_S(int plane, int sens) {
    static double noise_model_A[] = { 2.691353781189422e-06,2.6817014313123966e-06,2.682315890739256e-06,2.695296790679005e-06 };
    static double noise_model_B[] = { 5.607265966668617e-06,1.0263138748900872e-05,1.0650013817119217e-05,7.6267061661234736e-06 };
    double A = noise_model_A[plane];
    double B = noise_model_B[plane];
    double s = A * sens + B;
    return s < 0.0 ? 0.0 : s;
}

double compute_noise_model_entry_O(int plane, int sens) {
    static double noise_model_C[] = { 2.9917133034145296e-11,6.086258466440452e-11,6.308190715155536e-11,3.0739030068625654e-11 };
    static double noise_model_D[] = { 3.275624181535426e-07,6.624913143068297e-07,6.662466882279819e-07,3.1510627507887423e-07 };
    double digital_gain = (sens / 800.0) < 1.0 ? 1.0 : (sens / 800.0);
    double C = noise_model_C[plane];
    double D = noise_model_D[plane];
    double o = C * sens * sens + D * digital_gain * digital_gain;
    return o < 0.0 ? 0.0 : o;
}
